<%@ Page Language="C#"%>
<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data.Odbc" %>

<%

//************************************************************
//copy the properties of the incoming SMS into local variables
//************************************************************

string sender = Request.QueryString["sender"];
string receiver = Request.QueryString["receiver"];
string messagedata = Request.QueryString["messagedata"];
string messageid = Request.QueryString["messageid"];
string messagetype = Request.QueryString["messagetype"];
string senttime = Request.QueryString["senttime"];
string receivedtime = Request.QueryString["receivedtime"];
string serviceprovider = Request.QueryString["operatornames"];

string respmsg = "";

//************************************************************
//Create the responses for the messages
//************************************************************    

    //response message for the empty messagedata
		string RespForEmpty = "Welcome to the SMS information menu. If you want to receive information about the import possibilities, send the character 'i', if you want to receive information about export possibilities, send character 'e'";
    
        //response messages for letter 'i'
        Dictionary<string, string> RespForI =
                new Dictionary<string, string>();
        RespForI.Add("i", "1.public import \0x0D\0x0A2.cargo \0x0D\0x0A3.manifest \0x0D\0x0A4.temp import \0x0D\0x0A5.warehouse \0x0D\0x0A6.re-import");
    
        RespForI.Add("i1", "1.public import1 \0x0D\0x0A2.public import2 \0x0D\0x0A3.public import3 \0x0D\0x0A4.public import4 \0x0D\0x0A5.public import5 \0x0D\0x0A6.public import6 \0x0D\0x0A");
        RespForI.Add("i2", "2.cargo1 \0x0D\0x0A3.cargo2 \0x0D\0x0A4.cargo3 \0x0D\0x0A4.cargo4 \0x0D\0x0A5.cargo5 \0x0D\0x0A6.cargo6 \0x0D\0x0A");
        RespForI.Add("i3", "1.manifest1 \0x0D\0x0A2.manifest2 \0x0D\0x0A3.manifest3 \0x0D\0x0A4.manifest4 \0x0D\0x0A5.manifest5 \0x0D\0x0A6.manifest6 \0x0D\0x0A");
        RespForI.Add("i4", "1.temp import1 \0x0D\0x0A2.temp import2 \0x0D\0x0A3.temp import3 \0x0D\0x0A4.temp import4 \0x0D\0x0A5.temp import5 \0x0D\0x0A6.temp import6 \0x0D\0x0A");
        RespForI.Add("i5", "1.warehouse1 \0x0D\0x0A2.warehouse2 \0x0D\0x0A3.warehouse3 \0x0D\0x0A4.warehouse4 \0x0D\0x0A5.warehouse5 \0x0D\0x0A6.warehouse6 \0x0D\0x0A");
        RespForI.Add("i6", "1.re-import1 \0x0D\0x0A2.re-import2 \0x0D\0x0A3.re-import3 \0x0D\0x0A4.re-import4 \0x0D\0x0A5.re-import5 \0x0D\0x0A6.re-import6 \0x0D\0x0A");

        //response messages for letter 'e'
        Dictionary<string, string> RespForE =
                new Dictionary<string, string>();
        RespForE.Add("e", "1.public export. \0x0D\0x0A2.cargo \0x0D\0x0A3.re-export \0x0D\0x0A4.temp re-export \0x0D\0x0A5.export manifest \0x0D\0x0A6.countries");
    
        RespForE.Add("e1", "1.public export1 \0x0D\0x0A2.public export2 \0x0D\0x0A3.public export3 \0x0D\0x0A4.public export4 \0x0D\0x0A5.public export5 \0x0D\0x0A6.public export6 \0x0D\0x0A");
        RespForE.Add("e2", "1.cargo1 \0x0D\0x0A2.cargo2 \0x0D\0x0A3.cargo3 \0x0D\0x0A4.cargo4 \0x0D\0x0A5.cargo5 \0x0D\0x0A.6cargo6 \0x0D\0x0A");
        RespForE.Add("e3", "1.re-export1 \0x0D\0x0A2.re-export2 \0x0D\0x0A3.re-export3 \0x0D\0x0A4.re-export4 \0x0D\0x0A5.re-export5 \0x0D\0x0A6.re-export6 \0x0D\0x0A");
        RespForE.Add("e4", "1.temp re-export1 \0x0D\0x0A2.temp re-export2 \0x0D\0x0A3.temp re-export3 \0x0D\0x0A4.temp re-export4 \0x0D\0x0A5.temp re-export5 \0x0D\0x0A6.temp re-export6 \0x0D\0x0A");
        RespForE.Add("e5", "1.export manifest1 \0x0D\0x0A2.export manifest2 \0x0D\0x0A3.export manifest3 \0x0D\0x0A4.export manifest4 \0x0D\0x0A5.export manifest5 \0x0D\0x0A6.export manifest6 \0x0D\0x0A");
        RespForE.Add("e6", "1.countries1 \0x0D\0x0A2.countries2 \0x0D\0x0A3.countries3 \0x0D\0x0A4.countries4 \0x0D\0x0A5.countries5 \0x0D\0x0A6.countries6 \0x0D\0x0A");

        
//************************************************************
//Respond to the messages
//************************************************************    
        if (messagedata.Equals(""))
        {
            Response.Write("{SMS:TEXT:FORMATTED}{}{}{" + sender + "}{" + RespForEmpty + "}");
            
        }
        else
        {
            string phonestate = messagedata.Trim().ToLowerInvariant();
            string getPhoneState = "select `state` from `numbers` where `phonenum` = '" + sender + "'";
            
            try
            {
                string connectionString = "Driver={MySQL ODBC 5.1 Driver};Server=127.0.0.1;Database=MyInformation;User=root;Password=qwe123;Option=4;";
                OdbcConnection oc = new OdbcConnection(connectionString);
                oc.Open();
                try
                {

                    try
                    {
                        string sqlresp = "";
                        OdbcCommand command = new OdbcCommand(getPhoneState, oc);
                        OdbcDataReader reader = command.ExecuteReader();
                        while (reader.Read())
                        {
                            sqlresp = reader.GetString(0);
                        }
                        reader.Close();

                        //if the phone number is not yet stored, inserting it into the database
                        if (sqlresp == "")
                        {
                            string insertSQL = "insert into `numbers` (`phonenum`, `state`) values ('" + sender + "','" + phonestate + "');";
                            OdbcCommand storephonenum = new OdbcCommand(insertSQL, oc);
                            storephonenum.ExecuteNonQuery();
                        }
                            //if the phone number is stored in the datbase, modifying its phone state to according the current messagedata
                            //and updating the corresponding record in the database
                        else 
                        {
                            if (!(phonestate.EndsWith("i") || phonestate.EndsWith("e")))
                            {
                                phonestate = sqlresp + phonestate;
                                string updateSQL = "update `numbers` set `state`= '" + phonestate + "' where `phonenum` = '" + sender + "';";
                                OdbcCommand updatephonestate = new OdbcCommand(updateSQL, oc);
                                updatephonestate.ExecuteNonQuery();
                            }
                            else
                            {
                                string updateSQL = "update `numbers` set `state`= '" + phonestate + "' where `phonenum` = '" + sender + "';";
                                OdbcCommand updatephonestate = new OdbcCommand(updateSQL, oc);
                                updatephonestate.ExecuteNonQuery();
                            }
                            
                        }
                        
                        oc.Close();
                    }
                    catch (Exception z)
                    {
                        string errCode = z.Message;
                        Response.Write(errCode);
                    }

                }
                catch (Exception z)
                {
                    string errCode = z.Message;
                    Response.Write(errCode);
                }
            }
            catch (Exception z)
            {
                string errCode = z.Message;
                Response.Write(errCode);
            }
            
            //setting up the response messages for the recipient
            if (phonestate.StartsWith("i"))
            {
                respmsg = RespForI[phonestate];
            }

            if (phonestate.StartsWith("e"))
            {
                respmsg = RespForE[phonestate];
            }
            string respsms = "{SMS:TEXT:FORMATTED}{}{}{" + sender + "}{" + respmsg + "}";
            Response.Write(respsms);
        }
        
%>